#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>
#include "odicon.h"
#include "quadratic.h"


static double **m;
static double ifunc(int dim, int x[]) { return quadratic(dim, x, m); }

static void read_param(const int dim, int *init) {
    m = fmatrix_new(dim, dim);
    if (!fmatrix_scan(dim, m)) return;
    if (!ivector_scan(dim, init)) return;

    fmatrix_print(dim, m);
}

void demo_quadratic(const int dim, char MorL) {
    int i;
    int init[100];
    int upper[100];
    int lower[100];

    for (i=0; i<dim; i++) { lower[i] = -100; upper[i] = 100; }
    read_param(dim, init);

    switch (MorL) {
    case 'M':
        mgconv_minimize(dim, ifunc, init, lower, upper);
        break;
    case 'L':
        lgconv_minimize_IFF(dim, ifunc, init);
        /*lgconv_minimize_WOLFE(dim, ifunc, init);*/
        break;
    default:
        assert(0!=0);
        break;
    }
}
